﻿using System;
using System.Collections.Generic;
using System.IO;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using XMLFile;

namespace WSMeter
{
    [Serializable]
    public class Config
    {
        /// <summary>
        /// Путь к CSV-файлам
        /// </summary>
        public string CSVDir = "C:\\CSV\\";

        /// <summary>
        /// Путь к CSV-файлу
        /// </summary>
        public string CSVFile = "C:\\CSV\\Result.csv";

        /// <summary>
        /// Использовать файл для сохранения, не папку
        /// </summary>
        public bool UseCSVFile = false;

        /// <summary>
        /// Пользовательское поле 1
        /// </summary>
        public string User1 = "Art.nr";

        /// <summary>
        /// Пользовательское поле 2
        /// </summary>
        public string User2 = "Customer";

        /// <summary>
        /// Пользовательское поле 3
        /// </summary>
        public string User3 = "Packing station";

        /// <summary>
        /// IP-адрес устройства
        /// </summary>
        public string DeviceIP = "192.168.0.198";

        /// <summary>
        /// Порт
        /// </summary>
        public string SerialPort = "COM1";

        /// <summary>
        /// Удалённый порт
        /// </summary>
        public int RemotePort = 5554;

        /// <summary>
        /// Локальный порт
        /// </summary>
        public int LocalPort = 5554;

        /// <summary>
        /// Хэш пароля
        /// </summary>
        public string Hash = "e10154685bb47fbb19d676187456313c";

        /// <summary>
        /// Автосохранение
        /// </summary>
        public bool AutoSave = false;

        public void Save()
        {
            this.SaveXML("config.xml");
        }

        public static Config Load()
        {
            if (File.Exists("config.xml"))
            {
                try
                {
                    return XMLFile.XMLFile.LoadXML<Config>("config.xml");
                }
                catch(Exception)
                {
                    return new Config();
                }
            }
            else
                return new Config();
        }
    }
}
