﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace WSMeter.LabelConfig
{
    [Serializable]
    public class LabelCfg
    {
        public string Name = "58x78 mm";

        public int LabelBlockSize = 200; // K:220
        public int ValueBlockSize = 180; //

        public int LabelXOffset = 80;   // K: 20
        public int XStep = 80;          // K: 0

        public int LabelYOffset = 460;  // K: 400
        public int YStep = 0;           // K: -66

        public int ValueXOffset = 80;   // K: 220
        public int ValueYOffset = 260;  // K: 400

        public int BarcodeSize = 3;
        public int BarcodeXOffset = 45;
        public int BarcodeYOffset = 50;

        public string Font = "UB";     // K: PI

        public override string ToString()
        {
            return Name;
        }

        public string GetCommand()
        {
            string Cmd = "ID=PRINTER\n";
            Cmd += $"PR.LBLBLOCKSIZE={LabelBlockSize}\n";
            Cmd += $"PR.VALBLOCKSIZE={ValueBlockSize}\n";
            Cmd += $"PR.LBLXOFFSET={LabelXOffset}\n";
            Cmd += $"PR.XSTEP={XStep}\n";
            Cmd += $"PR.LBLYOFFSET={LabelYOffset}\n";
            Cmd += $"PR.YSTEP={YStep}\n";
            Cmd += $"PR.VALXOFFSET={ValueXOffset}\n";
            Cmd += $"PR.VALYOFFSET={ValueYOffset}\n";
            Cmd += $"PR.BARXOFFSET={BarcodeXOffset}\n";
            Cmd += $"PR.BARYOFFSET={BarcodeYOffset}\n";
            Cmd += $"PR.BARSIZE={BarcodeSize}\n";
            Cmd += $"PR.FONT={Font}\n";
            Cmd += $"SAVE\n"; 
            return Cmd;
        }

        public static string GetQueryCommand()
        {
            string Cmd = "ID=PRINTERQ\n";
            Cmd += $"PR.LBLBLOCKSIZE=?\n";
            Cmd += $"PR.VALBLOCKSIZE=?\n";
            Cmd += $"PR.LBLXOFFSET=?\n";
            Cmd += $"PR.XSTEP=?\n";
            Cmd += $"PR.LBLYOFFSET=?\n";
            Cmd += $"PR.YSTEP=?\n";
            Cmd += $"PR.VALXOFFSET=?\n";
            Cmd += $"PR.VALYOFFSET=?\n";
            Cmd += $"PR.BARXOFFSET=?\n";
            Cmd += $"PR.BARYOFFSET=?\n";
            Cmd += $"PR.BARSIZE=?\n";
            Cmd += $"PR.FONT=?\n";
            return Cmd;
        }
    }
}
