﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Text;
using System.Windows.Forms;

namespace Network.Control
{
    public class NetworkComboBox : ComboBox
    {
        public NetworkComboBox() : base()
        {
            DropDownStyle = ComboBoxStyle.DropDownList;
            CheckNetworks();
        }

        /// <summary>
        /// Проверить сети
        /// </summary>
        private void CheckNetworks()
        {
            Items.Clear();
            foreach (var I in NetworkSelector.getInterfaces(false))
            {
                if (I.Address.AddressFamily == System.Net.Sockets.AddressFamily.InterNetwork)
                    Items.Add(I);
            }

            if (Items.Count > 0) SelectedIndex = 0;
        }

        /// <summary>
        /// Выбранный интерфейс
        /// </summary>
        public NetworkInterface SelectedInterface
        {
            get { return (SelectedItem != null) ? SelectedItem as NetworkInterface : null; }
        }

        /// <summary>
        /// Выбран ли данный IP?
        /// </summary>
        /// <param name="Address"></param>
        /// <returns></returns>
        public bool isIPSelected(IPAddress Address)
        {
            return (SelectedItem != null) ? SelectedInterface.Address.Equals(Address) : false;
        }
    }
}
