﻿using System;
using System.Collections.Generic;
using System.IO;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace WSMeter.Output
{
    class CSV
    {
        /// <summary>
        /// Порядковый номер
        /// </summary>
        public int Id = 1;

        /// <summary>
        /// Получить текстовое представление очередной ячейки, null - больше ячеек нет
        /// </summary>
        /// <param name="Index"></param>
        /// <returns></returns>
        protected virtual string GetCell(int Index)
        {
            return null;
        }

        public void Save(string FileName)
        {
            File.WriteAllText(FileName, GetLine(), Encoding.UTF8);
        }

        public void Append(string FileName)
        {
            if (File.Exists(FileName))
            {
                var Res = File.ReadAllLines(FileName);

                Id = Res.Length + 1;
            }
            
            File.AppendAllText(FileName, GetLine() + "\r\n", Encoding.UTF8);
        }

        public string GetLine()
        {
            string Cell;
            int Index = 0;
            var Lines = new List<String>();
            while ((Cell = GetCell(Index++)) != null) Lines.Add(Cell);

            return (Index > 1) ? String.Join(";", Lines.ToArray()) : "";
        }
    }
}
