﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace WSMeter.Output
{
    class MeasureCSV : CSV
    {
        /// <summary>
        /// Длина
        /// </summary>
        public double Length;

        /// <summary>
        /// Ширина
        /// </summary>
        public double Width;

        /// <summary>
        /// Высота
        /// </summary>
        public double Height;

        /// <summary>
        /// Объём
        /// </summary>
        public double Volume;

        /// <summary>
        /// Вес
        /// </summary>
        public double Weight;

        /// <summary>
        /// ??
        /// </summary>
        public double VolumeWeight;

        /// <summary>
        /// Штрих-код
        /// </summary>
        public string Bar;

        /// <summary>
        /// Пользовательское значение 1
        /// </summary>
        public string UserValue1 = "";

        /// <summary>
        /// Пользовательское значение 2
        /// </summary>
        public string UserValue2 = "";

        /// <summary>
        /// Пользовательское значение 3
        /// </summary>
        public string UserValue3 = "";

        /// <summary>
        /// Получить текстовое представление очередной ячейки, null - больше ячеек нет
        /// </summary>
        /// <param name="Index"></param>
        /// <returns></returns>
        protected override string GetCell(int Index)
        {
            switch(Index)
            {
                case 0: return Id.ToString();
                case 1: return Length.ToString("0.00");
                case 2: return Width.ToString("0.00");
                case 3: return Height.ToString("0.00");
                case 4: return Volume.ToString("0.00");
                case 5: return Weight.ToString("0.00");
                case 6: return VolumeWeight.ToString("0.00");
                case 7: return "\"" + Bar + "\"";
                case 8: return "\"" + UserValue1 + "\"";
                case 9: return "\"" + UserValue2 + "\"";
                case 10: return "\"" + UserValue3 + "\"";
            }
            return null;
        }
    }
}
